# GIT


## Git Basics - Version Control

<div style="text-align: center;">
<iframe width="560" height="315" src="https://www.youtube.com/embed/5iFnzr73XXk" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
</div>

### Our problem

How many times have you done this?

```
project_final.doc
project_final_final.doc
project_final_final_this_one.doc
project_final_final_this_one_yes.doc
project_final_final_final_mega_final.doc
```

### Our solution - Version Control Systems

<div style="text-align: center">
<img src="https://imgs.xkcd.com/comics/git_2x.png" width="300px">
</div>
_source: [https://xkcd.com/1597/](https://xkcd.com/1597/)_

**Version Control** is the management of changes to documents, computer programs, large websites and other collection of information. There are two types of VCS:

- Centralized Version Control System (CVCS)
- Distributed Version Control System (DVCS)

#### Centralized VCS

Centralized version control system (CVCS) uses a central server to store all files and enables team collaboration. It works on a single repository to which users can directly access a central server.

![](https://i.imgur.com/06Z93zL.png)

_Drawbacks:_

- It is not locally available; meaning you always need to be connected to a network to perform any action
- Since everything is centralized, in any case of the central server getting crashed or corrupted will result in losing the entire data of the project


#### Distributed VCS

In Distributed VCS, every contributor has a local copy or 'clone' of the main repository i.e. everyone maintains a local repository of their own which contains all the files and metadata present in the main repository.

![](https://i.imgur.com/Mvru6ub.png)



### Welcome to Git

<img height="400px" src="https://upload.wikimedia.org/wikipedia/commons/thumb/e/e0/Git-logo.svg/1200px-Git-logo.svg.png" alt="Git-logo.svg">

**What is git?**

> Git is a **distributed version control system** for tracking changes in source code during software development. It is designed for coordinating work among programmers, but it can be used **to track changes in any set of files**. Its goals include speed, data integrity, and support for distributed, non-linear workflows.

**Why Git?**

- Free and Open Source
- Speed
- Scalable
- Reliable
- Distributed Development

#### Git Local/Remote Structure

As a reference, this is a basic structure of the local/remote structure using git.

![](https://image.slidesharecdn.com/gitbranchstregagycasestudywoogenius-140314152231-phpapp01/95/git-branch-stregagy-case-study-2-638.jpg?cb=1413975847)


### Interactions

Here there are some basic interactions you will normally do with your git repositories.

#### Cloning

Cloning takes a remote repository and literally _clones it_ into a local one:

```
git clone git@gitlab.com;flu/supermegasuperguay.git
```

#### Status

Shows what is the status of your local/remote repository - if there are local or remote changes, or things to be pushed:

```
git status
```

#### Log

Shows the history of the local and remote repositories as a list of commits with more info:

```
git log
```

#### Basic changes workflow

You will most likely be using this workflow for git

##### Pull-add-commit-push

- Download the last copy from the online repository and merge it with your local working directory:

    ```
    git pull
    ```

- Add the new files you added to git
    
    ```
    git add index.html
    ```

    or to review each `sloc`:

    ```
    git add -p
    ```

- Now name your update, so you know what you changed with this push.
    
    ```
    git commit -m "COMMIT MESSAGE"
    ```

!!! danger "About the commit message"
    This is a general point of failure for many many students (and instructors) that do not make a relevant commit message. 

    Write a **meaningful commit message**. This should answer the question: 
    > "If I apply this commit, I will... <commit message>". 
    
    For example: 
    > "uploading final project idea"
    
    This is not OK at all and will not help anyone to trace problems (and they will happen):

    ![](assets/bad-repo.png)

- Upload to the Repository

    ``` 
    git push
    ```

!!! warning "This is 1% of what git does"
    Git is much more than this. Do not hesitate to visit [the docs](https://git-scm.com/doc) to get more info or to follow a tutorial on more advanced features.

### Guidelines

!!! warning 
    Students can login on gitlab using their **email address** (the one they use for registration) and entering their Student ID as a temporary password (they need to change it asap)

#### Sizes

!!! warning 
    There's a soft limit on **300mb**.
    Sites reaching 300mb will be listed on a dedicated page in the archive for public _shame_. Site over 300mb for two weeks in a row will get special consideration.

The size of the repository is very important for faster deploys and image loads. **Images in a website don't need to weight more than 1Mb**.

!!! Note "Pro tip"
    Image optimization and why to do it:
    [Automating Image Optimization](https://developers.google.com/web/fundamentals/performance/optimizing-content-efficiency/automating-image-optimization/)

#### Tips and tricks

!!! warning "New with the terminal?"
    Visit [this guide](guides/code/terminal) to get started!

**Check the file-size of your folder!** 

You should commit 1-2MB per week. Not more!

Run the following command (Terminal or GitBash) in your folder to see folder and file-sizes:

```
du -sk * | sort -n
```

Each time you want to update your website, you should go through the following commands:

    ```
    cd ~/Desktop/fablabbcn
    git pull
    <change files - modify the files in your folder> 
    git status
    git add .
    git commit -m "<commit message>"
    git push
    ```

!!! Note
    If you end up in Vim-Editor, quit without saving by typing: `:q!`

!!! warning 
    Your website might not update in your Browser until you clear the cache (Hard Refresh!)
    
    If you still get error messages, [study git](https://try.github.io/) or write an email to your instructor.







[//]: # (Setting up git repo for MDEF)

## Setting up git

![](https://git-scm.com/images/logos/downloads/Git-Logo-Black.png)

!!! Note
    All information provided in this page comes from [here](https://git-scm.com/)

- **Windows**: [Gitbash](https://gitforwindows.org/) for windows users. This will install git and git bash, a terminal for using the command line in Windows other than the Power Shell.

- **Mac**: [command line](https://blog.teamtreehouse.com/introduction-to-the-mac-os-x-command-line) and install from [here](https://git-scm.com/download/mac). You can use [`homebrew`](https://brew.sh/) as a package manager. We recommend to install Xcode first (from the app store, for example) and then [`homebrew`](https://brew.sh/). 

- **Linux**: Use the command `sudo apt-get git` in the Linux Terminal.

### Make an account

- Make an account in [Github.com](https://github.com/) using the email you used in the program registration form

!!! danger "Format for the username"

    Make a username as such: `name_surname`

    For example if my name is...

    Andrés López Lee Peters: `andres_lopez`

    Or...

    Wongsathon Choonhavan: `wongsathon_choonhavan`

    Do not use dots in your username as you will have problems afterwords.

### Go local

- In your terminal, add your Git username and set your email

```
git config --global user.name "your_username"
```

- Configure you email address for uploading

```
git config --global user.email "your_email@mail.com"
```

### Generate SSH Keys

- Check if you have an SSH KEY already (If you see a long string starting with ssh-rsa, you can skip the ssh-keygen step):

```
cat ~/.ssh/id_rsa.pub
```

- Generate your SSH key:

```
ssh-keygen -t rsa -C "your_email@mail.com"
```

- Now let´s see your keygen

```
cat ~/.ssh/id_rsa.pub
```

- Copy your key:

**Windows**

```
clip < ~/.ssh/id_rsa.pub
```

**macOS**

```
pbcopy < ~/.ssh/id_rsa.pub
```

**linux**

```
xclip -sel clip < ~/.ssh/id_rsa.pub
```

### Go global Github

Add the copied key to [github.com](github.com) by following this [guide](https://docs.github.com/en/authentication/connecting-to-github-with-ssh/adding-a-new-ssh-key-to-your-github-account)

### Go global Gitlab

Add the copied key to [gitlab.fabcloud.org/](https://gitlab.fabcloud.org/) by following this [guide](https://docs.gitlab.com/ee/user/ssh.html)






[//]: # (GIT usual commands)

## Git usual commands

![](https://git-scm.com/images/logos/downloads/Git-Logo-Black.png)

### Normal Workflow

-  Files you changed

```
git add index.html
```

- In case you need to remove a tracked file

```
git rm
```

- Move or rename a file ,a directory or a symlinkgit

```
git mv
```

- To see what changed

```
git status
```

- Uploading the fab repository

```
git push origin master
```

**Update your archive when outdated and you have new files (merge from another git master repository)**

```
git remote -v
git fetch Academany ( in this case the repo to pull)
git merge Academany/master
```

Done, congrats!

### Terminal commands you will use to get to your archive folder.(it is recommended to not use capital letters)

### git+

- start a working area (see also: git help tutorial)
   **clone**      Clone a repository into a new directory
   **init**       Create an empty Git repository or reinitialize an existing one

- work on the current change (see also: git help everyday)
   **add**        Add file contents to the index
   **mv**         Move or rename a file, a directory, or a symlink
   **reset**      Reset current HEAD to the specified state
   **rm**         Remove files from the working tree and from the index

- examine the history and state (see also: git help revisions)
   **bisect**     Use binary search to find the commit that introduced a bug
   **grep**       Print lines matching a pattern
   **log**       Show commit logs
   **show**       Show various types of objects
   **status**     Show the working tree status

- grow, mark and tweak your common history
   **branch**     List, create, or delete branches
   **checkout**   Switch branches or restore working tree files
   **commit**     Record changes to the repository
   **diff**       Show changes between commits, commit and working tree, etc
   **merge**      Join two or more development histories together
   **rebase**     Forward-port local commits to the updated upstream head
   **tag**        Create, list, delete or verify a tag object signed with GPG

- collaborate (see also: git help workflows)
   **fetch**      Download objects and refs from another repository
   **pull**       Fetch from and integrate with another repository or a local branch
   **push**       Update remote refs along with associated objects




[//]: # (Git Resources)
## Resources

 * [A graphic explanation](https://onlywei.github.io/explain-git-with-d3/)
 * [Book](https://git-scm.com/book/en/v2)
 * [Git Branching](https://learngitbranching.js.org/)
 * [GitLab-Atom-Basics](https://doane-ccla.gitbook.io/docs/git-version-control/git-workflow)
 * [Guide for terminal basics](https://www.digitalcitizen.life/command-prompt-how-use-basic-commands)

